diff -uNr ./freebios2/src/arch/i386/boot/pirq_routing.c ../freebios2/src/arch/i386/boot/pirq_routing.c
--- ./freebios2/src/arch/i386/boot/pirq_routing.c	2003-04-24 22:02:24.000000000 -0400
+++ ../freebios2/src/arch/i386/boot/pirq_routing.c	2003-07-26 06:51:55.000000000 -0400
@@ -2,7 +2,7 @@
 #include <arch/pirq_routing.h>
 #include <string.h>
 
-#ifdef DEBUG
+#if DEBUG==1
 void check_pirq_routing_table(void)
 {
 	const uint8_t *addr;
diff -uNr ./freebios2/src/arch/i386/config/crt0.base ../freebios2/src/arch/i386/config/crt0.base
--- ./freebios2/src/arch/i386/config/crt0.base	2003-07-21 16:13:41.000000000 -0400
+++ ../freebios2/src/arch/i386/config/crt0.base	2003-07-26 06:53:51.000000000 -0400
@@ -24,7 +24,7 @@
 #include <arch/asm.h>
 #include <arch/intel.h>
 
-#ifdef CONFIG_SMP
+#if CONFIG_SMP==1
 #include <cpu/p6/apic.h>
 #endif
 /*
diff -uNr ./freebios2/src/arch/i386/config/make.base ../freebios2/src/arch/i386/config/make.base
--- ./freebios2/src/arch/i386/config/make.base	2003-04-25 23:20:51.000000000 -0400
+++ ../freebios2/src/arch/i386/config/make.base	2003-06-20 00:39:14.000000000 -0400
@@ -33,7 +33,8 @@
 addaction linuxbios.rom echo $$size ; \
 addaction linuxbios.rom dd if=linuxbios.strip of=linuxbios.rom bs=1 seek=`expr $(ROM_IMAGE_SIZE) - $$size`
 
-makerule payload.block : $(if $(PAYLOAD),$(PAYLOAD), /dev/null) ; perl -e '@stats=stat("$<"); $$sz=$$stats[7]; print "\xff" x ($(PAYLOAD_SIZE) - $$sz);' | cat $< - > $@
+#makerule payload.block : $(if $(PAYLOAD),$(PAYLOAD), /dev/null) ; perl -e '@stats=stat("$<"); $$sz=$$stats[7]; print "\xff" x ($(PAYLOAD_SIZE) - $$sz);' | cat $< - > $@
+makerule payload.block : $(if $(PAYLOAD),$(PAYLOAD), linux.bin.gz) ; dd conv=sync bs=$(PAYLOAD_SIZE) if=$< of=$@
 
 addaction clean rm -f romimage payload.*
 
diff -uNr ./freebios2/src/arch/i386/config/make.base.lb ../freebios2/src/arch/i386/config/make.base.lb
--- ./freebios2/src/arch/i386/config/make.base.lb	2003-06-24 14:39:11.000000000 -0400
+++ ../freebios2/src/arch/i386/config/make.base.lb	1969-12-31 19:00:00.000000000 -0500
@@ -1,29 +0,0 @@
-# due to a silliness, this has to be this way. 
-# we plan to fix this.
-ldscript config/ldscript.base
-
-# How do I add -mprefered-stack-boundary=2 if the compiler supports it?
-# On x86 tt results in a code size reduction.
-#
-
-dir /config
-
-makerule all dep "romimage"
-makerule floppy dep "all" act "mcopy -o romimage a:"
-makerule romimage dep "linuxbios.rom payload.block " act " cat payload.block linuxbios.rom > romimage"
-
-
-makerule nrv2b dep "$(TOP)/util/nrv2b/nrv2b.c " act " $(HOSTCC) -O2 -DENCODE -DDECODE -DMAIN -DVERBOSE -DNDEBUG -DBITSIZE=32 -DENDIAN=0 $< -o $@"
-
-makerule linuxbios.rom dep "linuxbios.strip buildrom" act "./buildrom $< $@ $(PAYLOAD) $(ROM_IMAGE_SIZE) $(ROM_SIZE)"
-#addaction linuxbios.rom "export size=`ls -l linuxbios.strip | (read p c u g size r ; echo $$size)` ; \\"
-#addaction linuxbios.rom "echo $$size ; \\"
-#addaction linuxbios.rom "dd if=linuxbios.strip of=linuxbios.rom bs=1 seek=`expr $(ROM_IMAGE_SIZE) - $$size`"
-
-#makerule payload.block dep "$(if $(PAYLOAD),$(PAYLOAD), /dev/null) " act " perl -e '@stats=stat(\"$<\"); $$sz=$$stats[7]; print "\xff" x ($(PAYLOAD_SIZE) - $$sz);' | cat $< - > $@"
-
-addaction clean "rm -f romimage payload.*"
-
-# do standard config files that the user need not specify
-# for now, this is just 'lib', but it may be more later. 
-dir /arch/i386
diff -uNr ./freebios2/src/arch/i386/Config.lb ../freebios2/src/arch/i386/Config.lb
--- ./freebios2/src/arch/i386/Config.lb	2003-07-25 17:43:12.000000000 -0400
+++ ../freebios2/src/arch/i386/Config.lb	2003-07-28 18:56:36.000000000 -0400
@@ -5,11 +5,6 @@
 	depends	"linuxbios.rom"
 end
 
-makerule floppy 
-	depends	"all" 
-	action	"mcopy -o romimage a:"
-end
-
 makerule nrv2b 
 	depends	"$(TOP)/util/nrv2b/nrv2b.c"
 	action	"$(HOSTCC) -O2 -DENCODE -DDECODE -DMAIN -DVERBOSE -DNDEBUG -DBITSIZE=32 -DENDIAN=0 $< -o $@"
@@ -33,7 +28,7 @@
 	action  "cp $< $@"
 end
 
-addaction clean "rm -f romimage payload.*"
+addaction clean "rm -f linuxbios.rom payload.*"
 
 dir lib
 dir boot
diff -uNr ./freebios2/src/arch/i386/include/arch/smp/mpspec.h ../freebios2/src/arch/i386/include/arch/smp/mpspec.h
--- ./freebios2/src/arch/i386/include/arch/smp/mpspec.h	2003-04-22 15:00:02.000000000 -0400
+++ ../freebios2/src/arch/i386/include/arch/smp/mpspec.h	2003-07-26 06:54:39.000000000 -0400
@@ -1,7 +1,7 @@
 #ifndef __ASM_MPSPEC_H
 #define __ASM_MPSPEC_H
 
-#ifdef HAVE_MP_TABLE
+#if HAVE_MP_TABLE==1
 
 /*
  * Structure definitions for SMP machines following the
diff -uNr ./freebios2/src/arch/i386/lib/cpu.c ../freebios2/src/arch/i386/lib/cpu.c
--- ./freebios2/src/arch/i386/lib/cpu.c	2003-07-19 00:28:20.000000000 -0400
+++ ../freebios2/src/arch/i386/lib/cpu.c	2003-07-26 06:57:46.000000000 -0400
@@ -35,7 +35,7 @@
 	 * so absolute minimum needed to get it going. 
 	 */
 	/* OK, linux it turns out does nothing. We have to do it ... */
-#if defined(i686) 
+#if i686==1
 	// totalram here is in linux sizing, i.e. units of KB. 
 	// set_mtrr is responsible for getting it into the right units!
 	setup_mtrrs(mem);
@@ -101,7 +101,7 @@
 		apic_read(APIC_ID));
 
 #else /* APIC */
-#ifdef i686
+#if i686==1
 	/* Only Pentium Pro and later have those MSR stuff */
 	msr_t msr;
 
diff -uNr ./freebios2/src/arch/i386/lib/c_start.S ../freebios2/src/arch/i386/lib/c_start.S
--- ./freebios2/src/arch/i386/lib/c_start.S	2003-07-21 16:13:41.000000000 -0400
+++ ../freebios2/src/arch/i386/lib/c_start.S	2003-07-26 06:55:25.000000000 -0400
@@ -1,6 +1,6 @@
 #include <arch/asm.h>
 #include <arch/intel.h>
-#ifdef CONFIG_SMP
+#if CONFIG_SMP==1
 #include <cpu/p6/apic.h>
 #endif
 	.section ".text"
@@ -39,7 +39,7 @@
 
 	/* set new stack */
 	movl	$_estack, %esp
-#ifdef CONFIG_SMP
+#if CONFIG_SMP==1
 	/* Get the cpu id */
 	movl	$APIC_DEFAULT_BASE, %edi
 	movl	APIC_ID(%edi), %eax
diff -uNr ./freebios2/src/arch/i386/smp/Config.lb ../freebios2/src/arch/i386/smp/Config.lb
--- ./freebios2/src/arch/i386/smp/Config.lb	2003-07-25 00:32:42.000000000 -0400
+++ ../freebios2/src/arch/i386/smp/Config.lb	2003-07-26 04:18:51.000000000 -0400
@@ -7,6 +7,6 @@
 #object ioapic.o CONFIG_IOAPIC
 if CONFIG_SMP
   object start_stop.o 
-  object secondary.S 
+  object secondary.S
 end
 
diff -uNr ./freebios2/src/config/Config.lb ../freebios2/src/config/Config.lb
--- ./freebios2/src/config/Config.lb	2003-07-22 21:42:29.000000000 -0400
+++ ../freebios2/src/config/Config.lb	2003-07-26 03:38:42.000000000 -0400
@@ -7,7 +7,7 @@
 makedefine GCC_INC_DIR := $(shell $(CC) -print-search-dirs | sed -ne "s/install: \(.*\)/\1include/gp")
 
 makedefine CPPFLAGS := -I$(TOP)/src/include -I$(TOP)/src/arch/$(ARCH)/include -I$(GCC_INC_DIR) $(CPUFLAGS)
-makedefine ROMCCPPFLAGS := -D__ROMCC__=0 -D__ROMCC_MINOR__=23
+makedefine ROMCCPPFLAGS := -D__ROMCC__=0 -D__ROMCC_MINOR__=34
 makedefine CFLAGS := $(CPU_OPT) $(CPPFLAGS) -Os -nostdinc -nostdlib -fno-builtin  -Wall
 
 makedefine HOSTCFLAGS:= -Os -Wall
@@ -116,7 +116,7 @@
 
 makerule ./romcc   
 	depends	"$(TOP)/util/romcc/romcc.c" 
-	action	"$(HOSTCC) -g $(HOSTCFLAGS) -DVERSION='\"0.21\"' -DRELEASE_DATE='\"7 april 2003\"' $< -o $@"
+	action	"$(HOSTCC) -g $(HOSTCFLAGS) -DVERSION='\"0.34\"' -DRELEASE_DATE='\"4 July 2003\"' $< -o $@"
 end
 
 makerule build_opt_tbl   
diff -uNr ./freebios2/src/config/Options.lb ../freebios2/src/config/Options.lb
--- ./freebios2/src/config/Options.lb	2003-07-25 13:31:53.000000000 -0400
+++ ../freebios2/src/config/Options.lb	2003-07-26 07:29:17.000000000 -0400
@@ -116,6 +116,11 @@
 	export always
 	comment "LinuxBIOS version"
 end
+define LINUXBIOS_EXTRA_VERSION
+        default ""
+        export used
+        comment "LinuxBIOS extra version"
+end
 define LINUXBIOS_BUILD
 	default "$(shell date)"
 	export always
@@ -238,7 +243,7 @@
 	comment "Default heap size"
 end
 define _RAMBASE
-	default 0x00100000
+	default 0x100000
 	format "0x%x"
 	export always
 	comment "Base address of RAM"
@@ -391,6 +396,11 @@
 	export always
 	comment "Define if we support SMP"
 end
+define CONFIG_MAX_CPUS
+        default 1
+        export always
+        comment "Config CPU count for this machine"
+end
 define MAX_CPUS
 	default 1
 	export always
diff -uNr ./freebios2/src/console/console.c ../freebios2/src/console/console.c
--- ./freebios2/src/console/console.c	2003-07-11 22:15:11.000000000 -0400
+++ ../freebios2/src/console/console.c	2003-07-26 06:58:58.000000000 -0400
@@ -57,7 +57,7 @@
  */
 void post_code(uint8_t value)
 {
-#ifdef CONFIG_SERIAL_POST
+#if CONFIG_SERIAL_POST==1
 	printk_info("POST: 0x%02x\n", value);
 #elsif !define(NO_POST)
 	outb(value, 0x80);
diff -uNr ./freebios2/src/cpu/p5/cpuid.c ../freebios2/src/cpu/p5/cpuid.c
--- ./freebios2/src/cpu/p5/cpuid.c	2003-07-19 00:28:21.000000000 -0400
+++ ../freebios2/src/cpu/p5/cpuid.c	2003-07-26 06:59:53.000000000 -0400
@@ -1,13 +1,13 @@
 #include <console/console.h>
 #include <cpu/p5/cpuid.h>
-#ifdef i586
+#if i586==1
 #include <cpu/p6/msr.h>
 #endif
 
 
 int mtrr_check(void)
 {
-#ifdef i686
+#if i686==1
 	/* Only Pentium Pro and later have MTRR */
 	msr_t msr;
 	printk_debug("\nMTRR check\n");
diff -uNr ./freebios2/src/mainboard/tyan/s2880/auto.c ../freebios2/src/mainboard/tyan/s2880/auto.c
--- ./freebios2/src/mainboard/tyan/s2880/auto.c	2003-07-24 23:05:54.000000000 -0400
+++ ../freebios2/src/mainboard/tyan/s2880/auto.c	2003-07-25 22:59:55.000000000 -0400
@@ -183,21 +183,21 @@
 	dump_pci_devices();
 #endif
 #if 0
-	dump_pci_device(PCI_DEV(0, 0x18, 2));
+	dump_pci_device(PCI_DEV(0, 0x18, 1));
 #endif
 
 	/* Check all of memory */
 #if 0
 	msr_t msr;
-	msr = rdmsr(TOP_MEM);
-	print_debug("TOP_MEM: ");
+	msr = rdmsr(TOP_MEM2);
+	print_debug("TOP_MEM2: ");
 	print_debug_hex32(msr.hi);
 	print_debug_hex32(msr.lo);
 	print_debug("\r\n");
 #endif
 /*
-#if 1
-	ram_check(0x00000000, msr.lo);
+#if  0
+	ram_check(0x00000000, msr.lo+(msr.hi<<32));
 #else
 #if TOTAL_CPUS < 2
 	// Check 16MB of memory @ 0
diff -uNr ./freebios2/src/mainboard/tyan/s2880/Config ../freebios2/src/mainboard/tyan/s2880/Config
--- ./freebios2/src/mainboard/tyan/s2880/Config	2003-07-24 23:05:54.000000000 -0400
+++ ../freebios2/src/mainboard/tyan/s2880/Config	2003-07-26 05:57:30.000000000 -0400
@@ -4,7 +4,7 @@
 arch i386
 cpu k8
 
-option DEBUG=0
+option DEBUG=1
 
 ##
 ## Build our 16 bit and 32 bit linuxBIOS entry code
@@ -112,8 +112,9 @@
 ##
 ## Build the objects we have code for in this directory.
 ##
-object mainboard.o
-#driver mainboard.o
+#object mainboard.o
+driver lsi_scsi.o
+driver mainboard.o
 object static_devices.o
 object mptable.o HAVE_MP_TABLE
 object irq_tables.o HAVE_PIRQ_TABLE
@@ -307,8 +308,8 @@
 ## Compute a range of ROM that can cached to speed up linuxBIOS,
 ## execution speed.
 ##
-expr XIP_ROM_SIZE = 98304 
-expr XIP_ROM_BASE = _ROMBASE + ROM_IMAGE_SIZE - XIP_ROM_SIZE
+#expr XIP_ROM_SIZE = 98304 
+#expr XIP_ROM_BASE = _ROMBASE + ROM_IMAGE_SIZE - XIP_ROM_SIZE
 #option XIP_ROM_SIZE=65536
 #option XIP_ROM_BASE=0xffff0000
 
diff -uNr ./freebios2/src/mainboard/tyan/s2880/Config.lb ../freebios2/src/mainboard/tyan/s2880/Config.lb
--- ./freebios2/src/mainboard/tyan/s2880/Config.lb	2003-07-25 00:32:42.000000000 -0400
+++ ../freebios2/src/mainboard/tyan/s2880/Config.lb	2003-07-26 05:18:20.000000000 -0400
@@ -16,9 +16,11 @@
 ### Build the objects we have code for in this directory.
 ###
 ##object mainboard.o
-config chip.h
-register "fixup_scsi" = "1"
+#config chip.h
+#register "fixup_scsi" = "1"
+
 driver mainboard.o
+driver lsi_scsi.o
 object static_devices.o
 if HAVE_MP_TABLE object mptable.o end
 if HAVE_PIRQ_TABLE object irq_tables.o end
@@ -128,8 +130,9 @@
 	action	"$(CPP) -I$(TOP)/src $(ROMCCPPFLAGS) $(CPPFLAGS) $(MAINBOARD)/auto.c > ./auto.E"
 end
 makerule ./auto.inc 
-	depends "./romcc ./auto.E" 
-	action	"./romcc -mcpu=k8  -O ./auto.E > auto.inc"
+	depends "./romcc ./auto.E"
+	action "./romcc -O -mcpu=k8 -o auto.inc --label-prefix=auto ./auto.E" 
+#	action	"./romcc -mcpu=k8  -O ./auto.E > auto.inc"
 end
 mainboardinit cpu/k8/enable_mmx_sse.inc
 mainboardinit ./auto.inc
@@ -152,10 +155,10 @@
 southbridge amd/amd8131
 end
 #mainboardinit archi386/smp/secondary.inc
-superio NSC/pc87360
-	register "com1" = "{1}"
-	register "lpt" = "{1}"
-end
+#superio NSC/pc87360
+#	register "com1" = "{1}"
+#	register "lpt" = "{1}"
+#end
 dir /pc80
 ##dir /src/superio/winbond/w83627hf
 cpu p5 end
diff -uNr ./freebios2/src/mainboard/tyan/s2880/debug.c ../freebios2/src/mainboard/tyan/s2880/debug.c
--- ./freebios2/src/mainboard/tyan/s2880/debug.c	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s2880/debug.c	2003-07-21 19:52:25.000000000 -0400
@@ -0,0 +1,127 @@
+
+static void print_debug_pci_dev(unsigned dev)
+{
+	print_debug("PCI: ");
+	print_debug_hex8((dev >> 16) & 0xff);
+	print_debug_char(':');
+	print_debug_hex8((dev >> 11) & 0x1f);
+	print_debug_char('.');
+	print_debug_hex8((dev >> 8) & 7);
+}
+
+static void print_pci_devices(void)
+{
+	device_t dev;
+	for(dev = PCI_DEV(0, 0, 0); 
+		dev <= PCI_DEV(0, 0x1f, 0x7); 
+		dev += PCI_DEV(0,0,1)) {
+		uint32_t id;
+		id = pci_read_config32(dev, PCI_VENDOR_ID);
+		if (((id & 0xffff) == 0x0000) || ((id & 0xffff) == 0xffff) ||
+			(((id >> 16) & 0xffff) == 0xffff) ||
+			(((id >> 16) & 0xffff) == 0x0000)) {
+			continue;
+		}
+		print_debug_pci_dev(dev);
+		print_debug("\r\n");
+	}
+}
+
+static void dump_pci_device(unsigned dev)
+{
+	int i;
+	print_debug_pci_dev(dev);
+	print_debug("\r\n");
+	
+	for(i = 0; i <= 255; i++) {
+		unsigned char val;
+		if ((i & 0x0f) == 0) {
+			print_debug_hex8(i);
+			print_debug_char(':');
+		}
+		val = pci_read_config8(dev, i);
+		print_debug_char(' ');
+		print_debug_hex8(val);
+		if ((i & 0x0f) == 0x0f) {
+			print_debug("\r\n");
+		}
+	}
+}
+
+static void dump_pci_devices(void)
+{
+	device_t dev;
+	for(dev = PCI_DEV(0, 0, 0); 
+		dev <= PCI_DEV(0, 0x1f, 0x7); 
+		dev += PCI_DEV(0,0,1)) {
+		uint32_t id;
+		id = pci_read_config32(dev, PCI_VENDOR_ID);
+		if (((id & 0xffff) == 0x0000) || ((id & 0xffff) == 0xffff) ||
+			(((id >> 16) & 0xffff) == 0xffff) ||
+			(((id >> 16) & 0xffff) == 0x0000)) {
+			continue;
+		}
+		dump_pci_device(dev);
+	}
+}
+
+static void dump_spd_registers(const struct mem_controller *ctrl)
+{
+	int i;
+	print_debug("\r\n");
+	for(i = 0; i < 4; i++) {
+		unsigned device;
+		device = ctrl->channel0[i];
+		if (device) {
+			int j;
+			print_debug("dimm: "); 
+			print_debug_hex8(i); 
+			print_debug(".0: ");
+			print_debug_hex8(device);
+			for(j = 0; j < 256; j++) {
+				int status;
+				unsigned char byte;
+				if ((j & 0xf) == 0) {
+					print_debug("\r\n");
+					print_debug_hex8(j);
+					print_debug(": ");
+				}
+				status = smbus_read_byte(device, j);
+				if (status < 0) {
+					print_debug("bad device\r\n");
+					break;
+				}
+				byte = status & 0xff;
+				print_debug_hex8(byte);
+				print_debug_char(' ');
+			}
+			print_debug("\r\n");
+		}
+		device = ctrl->channel1[i];
+		if (device) {
+			int j;
+			print_debug("dimm: "); 
+			print_debug_hex8(i); 
+			print_debug(".1: ");
+			print_debug_hex8(device);
+			for(j = 0; j < 256; j++) {
+				int status;
+				unsigned char byte;
+				if ((j & 0xf) == 0) {
+					print_debug("\r\n");
+					print_debug_hex8(j);
+					print_debug(": ");
+				}
+				status = smbus_read_byte(device, j);
+				if (status < 0) {
+					print_debug("bad device\r\n");
+					break;
+				}
+				byte = status & 0xff;
+				print_debug_hex8(byte);
+				print_debug_char(' ');
+			}
+			print_debug("\r\n");
+		}
+	}
+}
Binary files ./freebios2/src/mainboard/tyan/s2880/fwx.rom and ../freebios2/src/mainboard/tyan/s2880/fwx.rom differ
diff -uNr ./freebios2/src/mainboard/tyan/s2880/mainboard.c ../freebios2/src/mainboard/tyan/s2880/mainboard.c
--- ./freebios2/src/mainboard/tyan/s2880/mainboard.c	2003-07-25 00:32:42.000000000 -0400
+++ ../freebios2/src/mainboard/tyan/s2880/mainboard.c	2003-07-26 05:17:57.000000000 -0400
@@ -1,10 +1,10 @@
 #include <console/console.h>
 #include <device/device.h>
-#include <device/chip.h>
+//#include <device/chip.h>
 #include <device/pci.h>
 #include <device/pci_ids.h>
 #include <device/pci_ops.h>
-#include "chip.h"
+//#include "chip.h"
 //#include <part/mainboard.h>
 //#include "lsi_scsi.c"
 unsigned long initial_apicid[MAX_CPUS] =
@@ -105,7 +105,7 @@
 */
 }
  
-
+/*
 static void
 enable(struct chip *chip, enum chip_pass pass)
 {
@@ -135,4 +135,4 @@
 	        enable: enable,
 	        name:   "Tyan s2880 mainboard "
 };
-
+*/
diff -uNr ./freebios2/src/mainboard/tyan/s2880/static_devices.c ../freebios2/src/mainboard/tyan/s2880/static_devices.c
--- ./freebios2/src/mainboard/tyan/s2880/static_devices.c	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/s2880/static_devices.c	2003-06-24 20:25:02.000000000 -0400
@@ -0,0 +1,79 @@
+#include <console/console.h>
+#include <stdlib.h>
+#include <string.h>
+#include <device/resource.h>
+#include <device/device.h>
+#include <device/pci.h>
+
+struct cdev {
+	unsigned int devfn;
+	struct cdev *next;
+	struct cdev *children;
+	void *private;
+};
+static struct cdev nodev;
+
+#define DEV(NAME, DEVICE, FUNCTION, NEXT, CHILDREN, PRIVATE) \
+static struct cdev NEXT; \
+static struct cdev CHILDREN; \
+static struct cdev NAME = { \
+	.devfn = PCI_DEVFN(DEVICE, FUNCTION), \
+	.next = &NEXT, \
+	.children = &CHILDREN, \
+ 	.private = PRIVATE, \
+}
+
+DEV(dev0_2_0,  0x02, 0, dev0_1f_0, dev1_1c_0, 0);
+DEV(dev0_1f_0, 0x1f, 0, nodev,     nodev,     0);
+DEV(dev1_1c_0, 0x1c, 0, dev1_1e_0, nodev,     0);
+DEV(dev1_1e_0, 0x1e, 0, nodev,     nodev,     0);
+
+static void add_dev_list(struct device *bus, struct cdev *dev);
+
+static void add_device(struct device *bus, struct cdev *dev)
+{
+	struct device *pdev;
+
+#if 1
+	printk_debug("Adding%s %02x.%01x\n",
+		(dev->children == &nodev)?"":" bus",
+		PCI_SLOT(dev->devfn), PCI_FUNC(dev->devfn));
+#endif
+
+	pdev = malloc(sizeof(*pdev));
+	if (!pdev) 
+		goto no_mem;
+
+	memset(pdev, 0, sizeof(*pdev));
+	pdev->bus = bus;
+	pdev->devfn = dev->devfn;
+
+	/* Add to the list of devices on the parent bus. */
+	pdev->sibling = bus->children;
+	bus->children = pdev;
+
+	/* Add any children we might have */
+	add_dev_list(pdev, dev->children);
+	return;
+ no_mem:
+	printk_err("PCI: out of memory.\n");
+	return;
+}
+
+static void add_dev_list(struct device *bus, struct cdev *dev)
+{
+	while(dev != &nodev) {
+		add_device(bus, dev);
+		dev = dev->next;
+	}
+}
+void enumerate_static_devices(void)
+{
+#if 0
+	struct cdev *dev = &dev0_2_0;
+	add_dev_list(&dev_root, dev);
+#endif
+#if 0
+	dev_root.ops = &default_ht_ops_root;
+#endif
+}
diff -uNr ./freebios2/src/mainboard/tyan/s2880/tyan-fallback.config ../freebios2/src/mainboard/tyan/s2880/tyan-fallback.config
--- ./freebios2/src/mainboard/tyan/s2880/tyan-fallback.config	2003-07-24 23:05:54.000000000 -0400
+++ ../freebios2/src/mainboard/tyan/s2880/tyan-fallback.config	2003-07-26 05:59:09.000000000 -0400
@@ -4,7 +4,7 @@
 
 mainboard tyan/s2880 
 
-option LINUXBIOS_EXTRA_VERSION=$(shell cat ../../VERSION)Fallback
+option LINUXBIOS_EXTRA_VERSION=$(shell cat ../../VERSION)_Fallback
 
 ## Build a fallback not a normal image.
 option USE_FALLBACK_IMAGE=1
@@ -73,9 +73,9 @@
 ## SPEW       9   Way too many details             
 
 ## Request this level of debugging output
-option DEFAULT_CONSOLE_LOGLEVEL=7
+option DEFAULT_CONSOLE_LOGLEVEL=8
 ## At a maximum only compile in this level of debugging
-option MAXIMUM_CONSOLE_LOGLEVEL=8
+option MAXIMUM_CONSOLE_LOGLEVEL=9
 
 ## Use the elf bootloader
 option USE_ELF_BOOT=1
diff -uNr ./freebios2/src/mainboard/tyan/s2880/tyan-normal.config ../freebios2/src/mainboard/tyan/s2880/tyan-normal.config
--- ./freebios2/src/mainboard/tyan/s2880/tyan-normal.config	2003-07-24 23:05:54.000000000 -0400
+++ ../freebios2/src/mainboard/tyan/s2880/tyan-normal.config	2003-07-26 05:58:58.000000000 -0400
@@ -4,7 +4,7 @@
 
 mainboard tyan/s2880
 
-option LINUXBIOS_EXTRA_VERSION=$(shell cat ../../VERSION)Normal
+option LINUXBIOS_EXTRA_VERSION=$(shell cat ../../VERSION)_Normal
 
 ## Build a normal not a fallback image.
 option USE_FALLBACK_IMAGE=0
@@ -71,9 +71,9 @@
 ## SPEW       9   Way too many details             
 
 ## Request this level of debugging output
-option DEFAULT_CONSOLE_LOGLEVEL=6
+option DEFAULT_CONSOLE_LOGLEVEL=8
 ## At a maximum only compile in this level of debugging
-option MAXIMUM_CONSOLE_LOGLEVEL=6
+option MAXIMUM_CONSOLE_LOGLEVEL=9
 
 ## Use the elf bootloader
 option USE_ELF_BOOT=1
diff -uNr ./freebios2/src/mainboard/tyan/s2880/VERSION ../freebios2/src/mainboard/tyan/s2880/VERSION
--- ./freebios2/src/mainboard/tyan/s2880/VERSION	2003-07-21 16:13:43.000000000 -0400
+++ ../freebios2/src/mainboard/tyan/s2880/VERSION	1969-12-31 19:00:00.000000000 -0500
@@ -1 +0,0 @@
-2.0
diff -uNr ./freebios2/src/mainboard/tyan/VERSION ../freebios2/src/mainboard/tyan/VERSION
--- ./freebios2/src/mainboard/tyan/VERSION	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/src/mainboard/tyan/VERSION	2003-06-13 17:27:51.000000000 -0400
@@ -0,0 +1 @@
+2.0
diff -uNr ./freebios2/src/northbridge/amd/amdk8/raminit.c ../freebios2/src/northbridge/amd/amdk8/raminit.c
--- ./freebios2/src/northbridge/amd/amdk8/raminit.c	2003-07-24 23:05:54.000000000 -0400
+++ ../freebios2/src/northbridge/amd/amdk8/raminit.c	2003-07-25 22:38:17.000000000 -0400
@@ -919,6 +919,12 @@
 	 * [31: 8] Reserved
 	 */
 	PCI_ADDR(0, 0x18, 3, 0x60), 0xffffff00, 0x00000000,
+//BY LYH  add IOMMU 64M APERTURE
+	PCI_ADDR(0, 0x18, 3, 0x94), 0xffff8000, 0x00000f70,
+	PCI_ADDR(0, 0x18, 3, 0x90), 0xffffff80, 0x00000002,
+        PCI_ADDR(0, 0x18, 3, 0x98), 0x0000000f, 0x00068300,
+
+//BY LYH END
 	};
 	int i;
 	int max;
@@ -1116,7 +1122,23 @@
 		set_dimm_size(ctrl, sz, i);
 	}
 }
-
+static void fill_last(unsigned long node_id,unsigned long base)
+{
+//BY LYH //Fill next base reg with right value
+        unsigned i;
+        unsigned base_reg;
+        base &=0xffff0000;
+	device_t device;
+        for(device = PCI_DEV(0, 0x18, 1); device <= PCI_DEV(0, 0x1f, 1); device
++= PCI_DEV(0, 1, 0)) {
+        	for(i=node_id+1;i<=7;i++) {
+                	base_reg=0x40+(i<<3);
+                 	pci_write_config32(device,base_reg,base);
+		}
+        }
+//BY LYH END
+}
+ 
 static void route_dram_accesses(const struct mem_controller *ctrl,
 	unsigned long base_k, unsigned long limit_k)
 {
@@ -1126,6 +1148,7 @@
 	unsigned base;
 	unsigned index;
 	unsigned limit_reg, base_reg;
+
 	device_t device;
 	node_id = ctrl->node_id;
 	index = (node_id << 3);
@@ -1143,6 +1166,7 @@
 		pci_write_config32(device, limit_reg, limit);
 		pci_write_config32(device, base_reg, base);
 	}
+	
 }
 
 static void set_top_mem(unsigned tom_k)
@@ -1251,9 +1275,9 @@
 		/* Recompute the cs base register value */
 #if 1  // BY LYH  Need to count from 0 for every memory controller
 		csbase = ((tom - (base_k>>15))<< 21) | 1;
-		print_debug("csbase=");
-		print_debug_hex32(csbase);
-		print_debug("\r\n");
+//		print_debug("csbase=");
+//		print_debug_hex32(csbase);
+//		print_debug("\r\n");
 #else  //BY LYH END
                csbase = (tom << 21) | 1;
 #endif
@@ -1283,12 +1307,16 @@
 	print_debug("\r\n");
 #endif
 	route_dram_accesses(ctrl, base_k, tom_k);
+//BY LYH
+        fill_last(ctrl->node_id, tom_k<<2);
+//BY LYH END
 
 #if 0 //BY LYH
-	if(ctrl->node_id==1) {
-		pci_write_config32(ctrl->f2, DRAM_CSBASE, 0x00000001);
-	
-	}	
+        dump_pci_device(PCI_DEV(0, 0x18, 1));
+ 
+//	if(ctrl->node_id==1) {
+//		pci_write_config32(ctrl->f2, DRAM_CSBASE, 0x00000001);
+//	}	
 #endif 
 
 	set_top_mem(tom_k);
diff -uNr ./freebios2/src/southbridge/amd/amd8111/amd8111_ldtstop.c ../freebios2/src/southbridge/amd/amd8111/amd8111_ldtstop.c
--- ./freebios2/src/southbridge/amd/amd8111/amd8111_ldtstop.c	2003-07-25 10:37:10.000000000 -0400
+++ ../freebios2/src/southbridge/amd/amd8111/amd8111_ldtstop.c	2003-07-25 17:37:23.000000000 -0400
@@ -19,7 +19,7 @@
 	dev = pci_locate_device(PCI_ID(0x1022, 0x7468), 0);
 	
 	/* pin-strapping, but software programmable */
-	pci_write_config16(dev, 0x48, pci_read_config16(dev,0x48) & ~CPUPIN);
+	pci_write_config32(dev, 0x48, pci_read_config32(dev,0x48) & ~CPUPIN);
 
 	/* DevB:3 */
 	dev = pci_locate_device(PCI_ID(0x1022, 0x746b), 0);
diff -uNr ./freebios2/targets/tyan/s2880/Config.lb ../freebios2/targets/tyan/s2880/Config.lb
--- ./freebios2/targets/tyan/s2880/Config.lb	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/targets/tyan/s2880/Config.lb	2003-07-26 07:51:26.000000000 -0400
@@ -0,0 +1,254 @@
+# Sample config file for 
+# the Tyan s2880 
+# This will make a target directory of ./s2880
+
+loadoptions
+
+target s2880
+
+uses AMD8111_DEV
+uses ARCH
+uses CONFIG_COMPRESS
+uses CONFIG_IOAPIC
+uses CONFIG_ROM_STREAM
+uses CONFIG_ROM_STREAM_START
+uses CONFIG_SMP
+uses CONFIG_UDELAY_TSC
+uses CPU_FIXUP
+uses ENABLE_FIXED_AND_VARIABLE_MTRRS
+uses FALLBACK_SIZE
+uses FINAL_MAINBOARD_FIXUP
+uses HAVE_FALLBACK_BOOT
+uses HAVE_MP_TABLE
+uses HAVE_PIRQ_TABLE
+uses i586
+uses i686
+uses INTEL_PPRO_MTRR
+uses HEAP_SIZE
+uses IRQ_SLOT_COUNT
+uses k7
+uses k8
+uses MAINBOARD
+uses MAINBOARD_PART_NUMBER
+uses MAINBOARD_VENDOR
+uses MAX_CPUS
+#uses MEMORY_HOLE
+uses PAYLOAD_SIZE
+uses _RAMBASE
+uses _ROMBASE
+uses ROM_IMAGE_SIZE
+uses ROM_SECTION_OFFSET
+uses ROM_SECTION_SIZE
+uses ROM_SIZE
+uses SIO_BASE
+uses SIO_SYSTEM_CLK_INPUT
+uses STACK_SIZE
+uses USE_ELF_BOOT
+uses USE_FALLBACK_IMAGE
+uses USE_NORMAL_IMAGE
+uses USE_OPTION_TABLE
+uses HAVE_OPTION_TABLE
+#uses CONFIG_CHIP_CONFIGURE
+ 
+uses CONFIG_CONSOLE_SERIAL8250
+uses TTYS0_BAUD
+uses DEFAULT_CONSOLE_LOGLEVEL
+uses MAXIMUM_CONSOLE_LOGLEVEL
+uses DEBUG
+uses CONFIG_MAX_CPUS
+uses CONFIG_LOGICAL_CPUS
+uses MAX_PHYSICAL_CPUS
+uses LINUXBIOS_EXTRA_VERSION
+#uses XIP_ROM_SIZE
+#uses XIP_ROM_BASE
+
+#
+#uses CONFIG_LSI_SCSI_FW_FIXUP
+
+option HAVE_OPTION_TABLE=1
+option HAVE_MP_TABLE=1
+option CPU_FIXUP=1
+option CONFIG_UDELAY_TSC=0
+option i686=1
+option i586=1
+option INTEL_PPRO_MTRR=1
+option k7=1
+option k8=1
+option ROM_SIZE=524288
+
+# use the new chip configure code.
+
+#option CONFIG_CHIP_CONFIGURE=1
+#option CONFIG_LSI_SCSI_FW_FIXUP=1
+
+
+### Customize our winbond superio chip for this motherboard
+###
+option SIO_BASE=0x2e
+option SIO_SYSTEM_CLK_INPUT=0
+#
+###
+### Build code to export a programmable irq routing table
+###
+option HAVE_PIRQ_TABLE=1
+option IRQ_SLOT_COUNT=13
+#
+###
+### Build code for SMP support
+### Only worry about 2 micro processors
+###
+option CONFIG_SMP=1
+option CONFIG_MAX_CPUS=2
+option MAX_CPUS=2
+option CONFIG_LOGICAL_CPUS=0
+option MAX_PHYSICAL_CPUS=2
+#
+###
+### Build code to setup a generic IOAPIC
+###
+option CONFIG_IOAPIC=1
+#
+###
+### MEMORY_HOLE instructs earlymtrr.inc to
+### enable caching from 0-640KB and to disable 
+### caching from 640KB-1MB using fixed MTRRs 
+###
+### Enabling this option breaks SMP because secondary
+### CPU identification depends on only variable MTRRs
+### being enabled.
+###
+#option MEMORY_HOLE=0
+#
+###
+### Enable both fixed and variable MTRRS
+### When we setup MTRRs in mtrr.c  
+###
+### We must setup the fixed mtrrs or we confuse SMP secondary
+### processor identification
+###
+option ENABLE_FIXED_AND_VARIABLE_MTRRS=1
+#
+###
+### Clean up the motherboard id strings
+###
+option MAINBOARD_PART_NUMBER="S2880"
+option MAINBOARD_VENDOR="Tyan"
+#
+###
+### Call the final_mainboard_fixup function
+###
+option FINAL_MAINBOARD_FIXUP=1
+
+###
+### Compute the location and size of where this firmware image
+### (linuxBIOS plus bootloader) will live in the boot rom chip.
+###
+#option FALLBACK_SIZE=524288
+option FALLBACK_SIZE=98304
+
+## ROM_IMAGE_SIZE is the amount of space to allow linuxBIOS to occupy.
+option ROM_IMAGE_SIZE=65536
+ 
+
+###
+### Compute where this copy of linuxBIOS will start in the boot rom
+###
+#
+###
+### Compute a range of ROM that can cached to speed up linuxBIOS,
+### execution speed.
+###
+#expr XIP_ROM_SIZE = FALLBACK_SIZE
+#expr XIP_ROM_BASE = _ROMBASE + ROM_IMAGE_SIZE - XIP_ROM_SIZE
+##option XIP_ROM_SIZE=65536
+##option XIP_ROM_BASE=0xffff0000
+#
+## XIP_ROM_SIZE && XIP_ROM_BASE values that work.
+##option XIP_ROM_SIZE=0x8000
+##option XIP_ROM_BASE=0xffff8000
+
+## We don't use compressed image
+option CONFIG_COMPRESS=1
+
+option USE_ELF_BOOT=1
+
+
+option CONFIG_CONSOLE_SERIAL8250=1
+option TTYS0_BAUD=9600
+
+##
+### Select the linuxBIOS loglevel
+##
+## EMERG      1   system is unusable
+## ALERT      2   action must be taken immediately
+## CRIT       3   critical conditions
+## ERR        4   error conditions
+## WARNING    5   warning conditions
+## NOTICE     6   normal but significant condition
+## INFO       7   informational
+## DEBUG      8   debug-level messages
+## SPEW       9   Way too many details
+
+## Request this level of debugging output
+option DEFAULT_CONSOLE_LOGLEVEL=8
+## At a maximum only compile in this level of debugging
+option MAXIMUM_CONSOLE_LOGLEVEL=9
+
+option DEBUG=1
+
+option AMD8111_DEV=0x5
+
+#
+
+## LinuxBIOS C code runs at this location in RAM
+option _RAMBASE=0x004000
+
+##
+## Use a 64K stack
+##
+option STACK_SIZE=0x2000
+
+##
+## Use a 64K heap
+##
+option HEAP_SIZE=0x2000
+
+#
+###
+### Compute the start location and size size of
+### The linuxBIOS bootloader.
+###
+option PAYLOAD_SIZE            = (ROM_SECTION_SIZE - ROM_IMAGE_SIZE)
+option CONFIG_ROM_STREAM_START = (0xffffffff - ROM_SIZE + ROM_SECTION_OFFSET + 1)
+option CONFIG_ROM_STREAM     = 1
+option _ROMBASE      = (CONFIG_ROM_STREAM_START + PAYLOAD_SIZE)
+
+#option XIP_ROM_SIZE = FALLBACK_SIZE
+#option XIP_ROM_BASE = (_ROMBASE + ROM_IMAGE_SIZE - XIP_ROM_SIZE)
+
+
+#
+# 
+romimage "normal"
+#	option ROM_SIZE = (475136-FALLBACK_SIZE)
+        option ROM_SIZE = 475136
+        option LINUXBIOS_EXTRA_VERSION="$(shell cat ../../VERSION)_Normal"
+	option USE_FALLBACK_IMAGE=0
+	option ROM_SECTION_SIZE  = (ROM_SIZE - FALLBACK_SIZE)
+	option ROM_SECTION_OFFSET= 0
+	mainboard tyan/s2880
+	payload ../../tg3--ide_disk.zelf 
+end
+
+romimage "fallback" 
+#	option ROM_SIZE = FALLBACK_SIZE
+	option LINUXBIOS_EXTRA_VERSION="$(shell cat ../../VERSION)_Fallback"
+	option USE_FALLBACK_IMAGE=1
+	option HAVE_FALLBACK_BOOT=1
+	option ROM_SECTION_SIZE  = FALLBACK_SIZE
+	option ROM_SECTION_OFFSET= (ROM_SIZE - FALLBACK_SIZE)
+	mainboard tyan/s2880
+	payload ../../tg3.zelf
+end
+
+buildrom ROM_SIZE "normal" "fallback"
diff -uNr ./freebios2/targets/tyan/s2880/VERSION ../freebios2/targets/tyan/s2880/VERSION
--- ./freebios2/targets/tyan/s2880/VERSION	1969-12-31 19:00:00.000000000 -0500
+++ ../freebios2/targets/tyan/s2880/VERSION	2003-07-26 02:34:45.000000000 -0400
@@ -0,0 +1 @@
+2.0
